# RxJS Lite Join Patterns Module #

The Reactive Extensions for JavaScript also supports join calculus in that you can easily create patterns for when certain observable sequences fire. This module is designed to work with the `rx-lite` NPM module for both the standards-compliant version as well as compat for older browsers.

## Details ##

Files:
- [`rx.lite.joinpatterns.js`](https://github.com/Reactive-Extensions/RxJS/blob/master/modules/rx-lite-joinpatterns/rx.lite.joinpatterns.js)
- 
[`rx.lite.joinpatterns.compat.js`](https://github.com/Reactive-Extensions/RxJS/blob/master/modules/rx-lite-joinpatterns-compat/rx.lite.joinpatterns.compat.js)

NPM Packages:
- [`rx-lite-joinpatterns`](https://www.npmjs.org/package/rx-lite-joinpatterns)
- [`rx-lite-joinpatterns-compat`](https://www.npmjs.org/package/rx-lite-joinpatterns-compat)

File Dependencies:
- [`rx.lite.js`](https://github.com/Reactive-Extensions/RxJS/blob/master/dist/rx.lite.js)
- [`rx.lite.compat.js`](https://github.com/Reactive-Extensions/RxJS/blob/master/dist/rx.lite.compat.js)

## Included Observable Operators ##

### `Observable Methods`
- [`when`](../../api/core/operators/when.md)

### `Observable Instance Methods`
- [`and`](../../api/core/operators/and.md)

### `Pattern Instance Methods`
- [`thenDo`](../../api/core/operators/thendo.md)
